//+------------------------------------------------------------------+
//|                                                       vortex.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Red

//
//
//
//
//

extern int VortexPeriod = 14;

//
//
//
//
//

double vopBuffer[];
double vomBuffer[];
double vmpBuffer[];
double vmmBuffer[];
double rngBuffer[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,vopBuffer);
   SetIndexBuffer(1,vomBuffer);
   SetIndexBuffer(2,vmpBuffer);
   SetIndexBuffer(3,vmmBuffer);
   SetIndexBuffer(4,rngBuffer);
   IndicatorShortName("Vortex ( "+VortexPeriod+")");         
   return(0);
}

int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//


int start()
{
   int counted_bars=IndicatorCounted();
   int limit,i;

   if(counted_bars < 0)   return(-1);
   if(counted_bars > 0)   counted_bars--;
           limit = MathMax(Bars-counted_bars,Bars-2);
           
   //
   //
   //
   //
   //

      for(i = limit; i >= 0; i--)
      {
         rngBuffer[i] = MathMax(High[i],Close[i+1])-MathMin(Low[i],Close[i+1]);
         vmpBuffer[i] = MathAbs(High[i] - Low[i+1]);
         vmmBuffer[i] = MathAbs(Low[i] - High[i+1]);
         vopBuffer[i] = EMPTY_VALUE;
         vomBuffer[i] = EMPTY_VALUE;

         if ((Bars-i)<VortexPeriod) continue;
         
         //
         //
         //
         //
         //
         
            double vmpSum = 0;
            double vmmSum = 0;
            double rngSum = 0;
            for (int k=0; k<VortexPeriod; k++)
            {
               vmpSum += vmpBuffer[i+k];
               vmmSum += vmmBuffer[i+k];
               rngSum += rngBuffer[i+k];
            }
            if (rngSum !=0)
            {
               vopBuffer[i] = vmpSum/rngSum;
               vomBuffer[i] = vmmSum/rngSum;
            }
      }

   //
   //
   //
   //
   //

   return(0);      
}